USE [msdb]
GO

/****** Object:  Job [Report Subscriptions - Splitter]    Script Date: 02/21/2012 16:15:33 ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [[Uncategorized (Local)]]]    Script Date: 02/21/2012 16:15:33 ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Report Subscriptions - Splitter', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'CORP\roha49127', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Run Splitter]    Script Date: 02/21/2012 16:15:33 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Run Splitter', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'declare @srId int  --SubscriptionRequest ID
declare @batchId char(36)
declare @qry varchar(max)
declare @ReportParameters varchar(max)

--Create a cursor housing the pending Subscription Requests
declare sr cursor for
select cast(BatchId as char(36)), SubscriptionID
  from ReportSubscriptions.dbo.SubscriptionRequests
  where ProcessingStatusID = 0  
open sr
fetch next from sr into @batchId, @srId
while @@FETCH_STATUS = 0
begin
  
  --We need to run a query that will return one record for each report in the Subscription.
  --We''ll the need to insert the BatchID and the ReportParameters into ReportQueue for each report we want to generate. 
  --BatchID is a constant but ReportParameters is different for each record. 
  --We need a cursor to loop through so we can assemble the inserts into ReportQueue, but we can''t create from directly an exec.
  --As a standard, we''ll expect the query in the Subscription to insert a single column into a temp table named #ReportQueue.
  --Each record in the column inserted into #ReportQueue will contain an XML fragment housing all parameters needed to run an individual report.
  --We''ll then build insert statements using @batchID and the ReportParameters values from the cursor.
  
  --Pick up the query used to create a table housing report parameters for the report queue. 
  select @qry = Query from ReportSubscriptions.dbo.Subscriptions where SubscriptionID = @srId
  --Create & populate the temp table
  create table #report_queue (reportParms varchar(max))
  exec (@qry)
  --Create the report parameters cursor
  declare rp cursor for select reportParms from #report_queue
  open rp
  fetch next from rp into @ReportParameters
  while @@FETCH_STATUS = 0
  begin
    --Insert a seperate record for each report to be generated.
    insert into ReportSubscriptions.dbo.ReportQueue (BatchId, ReportParameters) values (@BatchId, @ReportParameters)
    fetch next from rp into @ReportParameters
  end  
  close rp
  deallocate rp
  drop table #report_queue
  --Update the status to show we are done splitting the request
  update ReportSubscriptions.dbo.SubscriptionRequests set ProcessingStatusID = 1 where BatchID = @batchId
  fetch next from sr into @batchId, @srId
end
close sr  
deallocate sr
', 
		@database_name=N'ReportSubscriptions', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Report Subscriptions - Splitter', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=5, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20110315, 
		@active_end_date=99991231, 
		@active_start_time=0, 
		@active_end_time=235959, 
		@schedule_uid=N'c18d621b-7dfb-43ec-86cc-7a0632f91a5e'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO


